Index: uspace/srv/net/app/ping/ping.c
===================================================================
--- uspace/srv/net/app/ping/ping.c	(revision 60ab6c32bdd1487d23ce71b9720e1b79f4c121ed)
+++ uspace/srv/net/app/ping/ping.c	(revision 71b00dcceb98187a198867584792b49778d8e886)
@@ -39,5 +39,4 @@
 #include <task.h>
 #include <time.h>
-#include <ipc/ipc.h>
 #include <ipc/services.h>
 
@@ -68,5 +67,56 @@
 /** Prints the application help.
  */
-void ping_print_help(void);
+void print_help(void);
+
+/** Translates the character string to the address family number.
+ *  @param[in] name The address family name.
+ *  @returns The corresponding address family number.
+ *  @returns EAFNOSUPPORTED if the address family is not supported.
+ */
+int parse_address_family(const char * name);
+
+void print_help(void){
+	printf(
+		"Network Ping aplication\n" \
+		"Usage: ping [options] numeric_address\n" \
+		"Where options are:\n" \
+		"\n" \
+		"-c request_count | --count=request_count\n" \
+		"\tThe number of packets the application sends. The default is three (3).\n" \
+		"\n" \
+		"--dont_fragment\n" \
+		"\tDisable packet fragmentation.\n"
+		"\n" \
+		"-f address_family | --family=address_family\n" \
+		"\tThe given address family. Only the AF_INET and AF_INET6 are supported.\n"
+		"\n" \
+		"-h | --help\n" \
+		"\tShow this application help.\n"
+		"\n" \
+		"-s packet_size | --size=packet_size\n" \
+		"\tThe packet data size the application sends. The default is 38 bytes.\n" \
+		"\n" \
+		"-t timeout | --timeout=timeout\n" \
+		"\tThe number of miliseconds the application waits for a reply. The default is three thousands (3 000).\n" \
+		"\n" \
+		"--tos=tos\n" \
+		"\tThe type of service to be used.\n" \
+		"\n" \
+		"--ttl=ttl\n" \
+		"\tThe time to live to be used.\n" \
+		"\n" \
+		"-v | --verbose\n" \
+		"\tShow all output messages.\n"
+	);
+}
+
+int parse_address_family(const char * name){
+	if(str_lcmp(name, "AF_INET", 7) == 0){
+		return AF_INET;
+	}else if(str_lcmp(name, "AF_INET6", 8) == 0){
+		return AF_INET6;
+	}
+	return EAFNOSUPPORT;
+}
 
 int main(int argc, char * argv[]){
@@ -76,13 +126,13 @@
 	int verbose			= 0;
 	int dont_fragment	= 0;
-	ip_ttl_t ttl		= 0;
-	ip_tos_t tos		= 0;
+	ip_ttl_t ttl				= 0;
+	ip_tos_t tos				= 0;
 	int count			= 3;
-	suseconds_t timeout	= 3000;
+	suseconds_t timeout			= 3000;
 	int family			= AF_INET;
 
-	socklen_t max_length				= sizeof(struct sockaddr_in6);
+	socklen_t max_length		= sizeof(struct sockaddr_in6);
 	uint8_t address_data[max_length];
-	struct sockaddr * address			= (struct sockaddr *) address_data;
+	struct sockaddr * address		= (struct sockaddr *) address_data;
 	struct sockaddr_in * address_in		= (struct sockaddr_in *) address;
 	struct sockaddr_in6 * address_in6	= (struct sockaddr_in6 *) address;
@@ -97,15 +147,15 @@
 	int index;
 
-	// print the program label
 	printf("Task %d - ", task_get_id());
 	printf("%s\n", NAME);
 
-	// parse the command line arguments
-	// stop before the last argument if it does not start with the minus sign ('-')
-	for(index = 1; (index < argc - 1) || ((index == argc - 1) && (argv[index][0] == '-')); ++ index){
-		// options should start with the minus sign ('-')
+	if(argc <= 1){
+		print_help();
+		return EINVAL;
+	}
+
+	for(index = 1; (index < argc - 1) || ((index == argc) && (argv[index][0] == '-')); ++ index){
 		if(argv[index][0] == '-'){
 			switch(argv[index][1]){
-				// short options with only one letter
 				case 'c':
 					ERROR_PROPAGATE(parse_parameter_int(argc, argv, &index, &count, "count", 0));
@@ -115,5 +165,5 @@
 					break;
 				case 'h':
-					ping_print_help();
+					print_help();
 					return EOK;
 					break;
@@ -129,5 +179,4 @@
 					verbose = 1;
 					break;
-				// long options with the double minus sign ('-')
 				case '-':
 					if(str_lcmp(argv[index] + 2, "count=", 6) == 0){
@@ -138,5 +187,5 @@
 						ERROR_PROPAGATE(parse_parameter_name_int(argc, argv, &index, &family, "address family", 9, parse_address_family));
 					}else if(str_lcmp(argv[index] + 2, "help", 5) == 0){
-						ping_print_help();
+						print_help();
 						return EOK;
 					}else if(str_lcmp(argv[index] + 2, "size=", 5) == 0){
@@ -156,5 +205,5 @@
 					}else{
 						print_unrecognized(index, argv[index] + 2);
-						ping_print_help();
+						print_help();
 						return EINVAL;
 					}
@@ -162,22 +211,14 @@
 				default:
 					print_unrecognized(index, argv[index] + 1);
-					ping_print_help();
+					print_help();
 					return EINVAL;
 			}
 		}else{
 			print_unrecognized(index, argv[index]);
-			ping_print_help();
+			print_help();
 			return EINVAL;
 		}
 	}
 
-	// if not before the last argument containing the address
-	if(index >= argc){
-		printf("Command line error: missing address\n");
-		ping_print_help();
-		return EINVAL;
-	}
-
-	// prepare the address buffer
 	bzero(address_data, max_length);
 	switch(family){
@@ -197,5 +238,4 @@
 	}
 
-	// parse the last argument which should contain the address
 	if(ERROR_OCCURRED(inet_pton(family, argv[argc - 1], address_start))){
 		fprintf(stderr, "Address parse error %d\n", ERROR_CODE);
@@ -203,5 +243,4 @@
 	}
 
-	// connect to the ICMP module
 	icmp_phone = icmp_connect_module(SERVICE_ICMP, ICMP_CONNECT_TIMEOUT);
 	if(icmp_phone < 0){
@@ -210,5 +249,4 @@
 	}
 
-	// print the ping header
 	printf("PING %d bytes of data\n", size);
 	if(ERROR_OCCURRED(inet_ntop(address->sa_family, address_start, address_string, sizeof(address_string)))){
@@ -218,27 +256,14 @@
 	}
 
-	// do count times
 	while(count > 0){
-
-		// get the starting time
 		if(ERROR_OCCURRED(gettimeofday(&time_before, NULL))){
 			fprintf(stderr, "Get time of day error %d\n", ERROR_CODE);
-			// release the ICMP phone
-			ipc_hangup(icmp_phone);
 			return ERROR_CODE;
 		}
-
-		// request the ping
 		result = icmp_echo_msg(icmp_phone, size, timeout, ttl, tos, dont_fragment, address, addrlen);
-
-		// get the ending time
 		if(ERROR_OCCURRED(gettimeofday(&time_after, NULL))){
 			fprintf(stderr, "Get time of day error %d\n", ERROR_CODE);
-			// release the ICMP phone
-			ipc_hangup(icmp_phone);
 			return ERROR_CODE;
 		}
-
-		// print the result
 		switch(result){
 			case ICMP_ECHO:
@@ -258,45 +283,7 @@
 	}
 
-	// release the ICMP phone
-	ipc_hangup(icmp_phone);
-
 	return EOK;
 }
 
-void ping_print_help(void){
-	printf(
-		"Network Ping aplication\n" \
-		"Usage: ping [options] numeric_address\n" \
-		"Where options are:\n" \
-		"\n" \
-		"-c request_count | --count=request_count\n" \
-		"\tThe number of packets the application sends. The default is three (3).\n" \
-		"\n" \
-		"--dont_fragment\n" \
-		"\tDisable packet fragmentation.\n"
-		"\n" \
-		"-f address_family | --family=address_family\n" \
-		"\tThe given address family. Only the AF_INET and AF_INET6 are supported.\n"
-		"\n" \
-		"-h | --help\n" \
-		"\tShow this application help.\n"
-		"\n" \
-		"-s packet_size | --size=packet_size\n" \
-		"\tThe packet data size the application sends. The default is 38 bytes.\n" \
-		"\n" \
-		"-t timeout | --timeout=timeout\n" \
-		"\tThe number of miliseconds the application waits for a reply. The default is three thousands (3 000).\n" \
-		"\n" \
-		"--tos=tos\n" \
-		"\tThe type of service to be used.\n" \
-		"\n" \
-		"--ttl=ttl\n" \
-		"\tThe time to live to be used.\n" \
-		"\n" \
-		"-v | --verbose\n" \
-		"\tShow all output messages.\n"
-	);
-}
-
 /** @}
  */
Index: uspace/srv/net/checksum.c
===================================================================
--- uspace/srv/net/checksum.c	(revision 60ab6c32bdd1487d23ce71b9720e1b79f4c121ed)
+++ uspace/srv/net/checksum.c	(revision 71b00dcceb98187a198867584792b49778d8e886)
@@ -47,11 +47,60 @@
 #define CRC_DIVIDER_LE	0xEDB88320
 
-uint16_t compact_checksum(uint32_t sum){
-	// shorten to the 16 bits
-	while(sum >> 16){
-		sum = (sum &0xFFFF) + (sum >> 16);
+uint32_t compute_crc32_le(uint32_t seed, uint8_t * data, size_t length){
+	size_t index;
+
+	while(length >= 8){
+		seed ^= (*data);
+		for(index = 0; index < 8; ++ index){
+			if(seed &1){
+				seed = (seed >> 1) ^ ((uint32_t) CRC_DIVIDER_LE);
+			}else{
+				seed >>= 1;
+			}
+		}
+		++ data;
+		length -= 8;
 	}
+	if(length > 0){
+		seed ^= (*data) >> (8 - length);
+		for(index = 0; index < length; ++ index){
+			if(seed &1){
+				seed = (seed >> 1) ^ ((uint32_t) CRC_DIVIDER_LE);
+			}else{
+				seed >>= 1;
+			}
+		}
+		length -= 8;
+	}
+	return seed;
+}
 
-	return (uint16_t) sum;
+uint32_t compute_crc32_be(uint32_t seed, uint8_t * data, size_t length){
+	size_t index;
+
+	while(length >= 8){
+		seed ^= (*data) << 24;
+		for(index = 0; index < 8; ++ index){
+			if(seed &0x80000000){
+				seed = (seed << 1) ^ ((uint32_t) CRC_DIVIDER_BE);
+			}else{
+				seed <<= 1;
+			}
+		}
+		++ data;
+		length -= 8;
+	}
+	if(length > 0){
+		seed ^= ((*data) &(0xFF << (8 - length))) << 24;
+		for(index = 0; index < length; ++ index){
+			if(seed &0x80000000){
+				seed = (seed << 1) ^ ((uint32_t) CRC_DIVIDER_BE);
+			}else{
+				seed <<= 1;
+			}
+		}
+		length -= 8;
+	}
+	return seed;
 }
 
@@ -72,87 +121,11 @@
 }
 
-uint32_t compute_crc32_be(uint32_t seed, uint8_t * data, size_t length){
-	size_t index;
-
-	// process full bytes
-	while(length >= 8){
-		// add the data
-		seed ^= (*data) << 24;
-		// for each added bit
-		for(index = 0; index < 8; ++ index){
-			// if the first bit is set
-			if(seed &0x80000000){
-				// shift and divide the checksum
-				seed = (seed << 1) ^ ((uint32_t) CRC_DIVIDER_BE);
-			}else{
-				// shift otherwise
-				seed <<= 1;
-			}
-		}
-		// move to the next byte
-		++ data;
-		length -= 8;
+uint16_t compact_checksum(uint32_t sum){
+	// shorten to the 16 bits
+	while(sum >> 16){
+		sum = (sum &0xFFFF) + (sum >> 16);
 	}
 
-	// process the odd bits
-	if(length > 0){
-		// add the data with zero padding
-		seed ^= ((*data) &(0xFF << (8 - length))) << 24;
-		// for each added bit
-		for(index = 0; index < length; ++ index){
-			// if the first bit is set
-			if(seed &0x80000000){
-				// shift and divide the checksum
-				seed = (seed << 1) ^ ((uint32_t) CRC_DIVIDER_BE);
-			}else{
-				// shift otherwise
-				seed <<= 1;
-			}
-		}
-	}
-
-	return seed;
-}
-
-uint32_t compute_crc32_le(uint32_t seed, uint8_t * data, size_t length){
-	size_t index;
-
-	// process full bytes
-	while(length >= 8){
-		// add the data
-		seed ^= (*data);
-		// for each added bit
-		for(index = 0; index < 8; ++ index){
-			// if the last bit is set
-			if(seed &1){
-				// shift and divide the checksum
-				seed = (seed >> 1) ^ ((uint32_t) CRC_DIVIDER_LE);
-			}else{
-				// shift otherwise
-				seed >>= 1;
-			}
-		}
-		// move to the next byte
-		++ data;
-		length -= 8;
-	}
-
-	// process the odd bits
-	if(length > 0){
-		// add the data with zero padding
-		seed ^= (*data) >> (8 - length);
-		for(index = 0; index < length; ++ index){
-			// if the last bit is set
-			if(seed &1){
-				// shift and divide the checksum
-				seed = (seed >> 1) ^ ((uint32_t) CRC_DIVIDER_LE);
-			}else{
-				// shift otherwise
-				seed >>= 1;
-			}
-		}
-	}
-
-	return seed;
+	return (uint16_t) sum;
 }
 
@@ -164,5 +137,4 @@
 
 uint16_t ip_checksum(uint8_t * data, size_t length){
-	// compute, compact and flip the data checksum
 	return flip_checksum(compact_checksum(compute_checksum(0, data, length)));
 }
Index: uspace/srv/net/err.h
===================================================================
--- uspace/srv/net/err.h	(revision 60ab6c32bdd1487d23ce71b9720e1b79f4c121ed)
+++ uspace/srv/net/err.h	(revision 71b00dcceb98187a198867584792b49778d8e886)
@@ -62,7 +62,5 @@
 #ifdef CONFIG_DEBUG
 
-#define ERROR_OCCURRED(value)												\
-	(((ERROR_CODE = (value)) != EOK)										\
-	&& ({printf("error at %s:%d %d\n", __FILE__, __LINE__, ERROR_CODE); 1;}))
+#define ERROR_OCCURRED(value)		(((ERROR_CODE = (value)) != EOK) && ({printf("error at %s:%d %d\n", __FILE__, __LINE__, ERROR_CODE); 1;}))
 
 #else
Index: uspace/srv/net/il/arp/arp_messages.h
===================================================================
--- uspace/srv/net/il/arp/arp_messages.h	(revision 60ab6c32bdd1487d23ce71b9720e1b79f4c121ed)
+++ uspace/srv/net/il/arp/arp_messages.h	(revision 71b00dcceb98187a198867584792b49778d8e886)
@@ -46,24 +46,24 @@
  */
 typedef enum{
-	/** Clean cache message.
-	 *  @see arp_clean_cache()
+	/** New device message.
+	 *  @see arp_device_req()
 	 */
-	NET_ARP_CLEAN_CACHE = NET_ARP_FIRST,
+	NET_ARP_DEVICE = NET_ARP_FIRST,
+	/** Address translation message.
+	 *  @see arp_translate_req()
+	 */
+	NET_ARP_TRANSLATE,
+	/** Clear device cache message.
+	 *  @see arp_clear_device_req()
+	 */
+	NET_ARP_CLEAR_DEVICE,
 	/** Clear address cache message.
 	 *  @see arp_clear_address_msg()
 	 */
 	NET_ARP_CLEAR_ADDRESS,
-	/** Clear device cache message.
-	 *  @see arp_clear_device_req()
+	/** Clean cache message.
+	 *  @see arp_clean_cache()
 	 */
-	NET_ARP_CLEAR_DEVICE,
-	/** New device message.
-	 *  @see arp_device_req()
-	 */
-	NET_ARP_DEVICE,
-	/** Address translation message.
-	 *  @see arp_translate_req()
-	 */
-	NET_ARP_TRANSLATE
+	NET_ARP_CLEAN_CACHE,
 } arp_messages;
 
Index: uspace/srv/net/il/il_messages.h
===================================================================
--- uspace/srv/net/il/il_messages.h	(revision 60ab6c32bdd1487d23ce71b9720e1b79f4c121ed)
+++ uspace/srv/net/il/il_messages.h	(revision 71b00dcceb98187a198867584792b49778d8e886)
@@ -53,12 +53,4 @@
 	 */
 	NET_IL_DEVICE_STATE,
-	/** Device MTU changed message.
-	 *  @see il_mtu_changed_msg()
-	 */
-	NET_IL_MTU_CHANGED,
-	/** Packet size message.
-	 *  @see il_packet_size_req()
-	 */
-	NET_IL_PACKET_SPACE,
 	/** Packet received message.
 	 *  @see il_received_msg()
@@ -68,5 +60,13 @@
 	 *  @see il_send_msg()
 	 */
-	NET_IL_SEND
+	NET_IL_SEND,
+	/** Packet size message.
+	 *  @see il_packet_size_req()
+	 */
+	NET_IL_PACKET_SPACE,
+	/** Device MTU changed message.
+	 *  @see il_mtu_changed_msg()
+	 */
+	NET_IL_MTU_CHANGED
 } il_messages;
 
@@ -83,5 +83,5 @@
  *  @param[in] call The message call structure.
  */
-#define IL_GET_SERVICE(call)	(services_t) IPC_GET_ARG2(*call)
+#define IL_GET_SERVICE(call)		(services_t) IPC_GET_ARG2(*call)
 
 /*@}*/
Index: uspace/srv/net/il/ip/ip_client.c
===================================================================
--- uspace/srv/net/il/ip/ip_client.c	(revision 60ab6c32bdd1487d23ce71b9720e1b79f4c121ed)
+++ uspace/srv/net/il/ip/ip_client.c	(revision 71b00dcceb98187a198867584792b49778d8e886)
@@ -48,4 +48,60 @@
 #include "ip_header.h"
 
+int ip_client_prepare_packet(packet_t packet, ip_protocol_t protocol, ip_ttl_t ttl, ip_tos_t tos, int dont_fragment, size_t ipopt_length){
+	ip_header_ref header;
+	uint8_t * data;
+	size_t padding;
+
+	padding =  ipopt_length % 4;
+	if(padding){
+		padding = 4 - padding;
+		ipopt_length += padding;
+	}
+	data = (uint8_t *) packet_prefix(packet, sizeof(ip_header_t) + padding);
+	if(! data){
+		return ENOMEM;
+	}
+	while(padding --){
+		data[sizeof(ip_header_t) + padding] = IPOPT_NOOP;
+	}
+	header = (ip_header_ref) data;
+	header->header_length = IP_COMPUTE_HEADER_LENGTH(sizeof(ip_header_t) + ipopt_length);
+	header->ttl = (ttl ? ttl : IPDEFTTL); //(((ttl) <= MAXTTL) ? ttl : MAXTTL) : IPDEFTTL;
+	header->tos = tos;
+	header->protocol = protocol;
+	if(dont_fragment){
+		header->flags = IPFLAG_DONT_FRAGMENT;
+	}
+	return EOK;
+}
+
+int ip_client_process_packet(packet_t packet, ip_protocol_t * protocol, ip_ttl_t * ttl, ip_tos_t * tos, int * dont_fragment, size_t * ipopt_length){
+	ip_header_ref header;
+
+	header = (ip_header_ref) packet_get_data(packet);
+	if((! header)
+		|| (packet_get_data_length(packet) < sizeof(ip_header_t))){
+		return ENOMEM;
+	}
+	if(protocol){
+		*protocol = header->protocol;
+	}
+	if(ttl){
+		*ttl = header->ttl;
+	}
+	if(tos){
+		*tos = header->tos;
+	}
+	if(dont_fragment){
+		*dont_fragment = header->flags &IPFLAG_DONT_FRAGMENT;
+	}
+	if(ipopt_length){
+		*ipopt_length = IP_HEADER_LENGTH(header) - sizeof(ip_header_t);
+		return sizeof(ip_header_t);
+	}else{
+		return IP_HEADER_LENGTH(header);
+	}
+}
+
 size_t ip_client_header_length(packet_t packet){
 	ip_header_ref header;
@@ -57,4 +113,19 @@
 	}
 	return IP_HEADER_LENGTH(header);
+}
+
+int ip_client_set_pseudo_header_data_length(ip_pseudo_header_ref header, size_t headerlen, size_t data_length){
+	ipv4_pseudo_header_ref header_in;
+
+	if(! header){
+		return EBADMEM;
+	}
+	if(headerlen == sizeof(ipv4_pseudo_header_t)){
+		header_in = (ipv4_pseudo_header_ref) header;
+		header_in->data_length = htons(data_length);
+		return EOK;
+	}else{
+		return EINVAL;
+	}
 }
 
@@ -69,5 +140,4 @@
 		return EINVAL;
 	}
-
 	switch(src->sa_family){
 		case AF_INET:
@@ -101,87 +171,4 @@
 }
 
-int ip_client_prepare_packet(packet_t packet, ip_protocol_t protocol, ip_ttl_t ttl, ip_tos_t tos, int dont_fragment, size_t ipopt_length){
-	ip_header_ref header;
-	uint8_t * data;
-	size_t padding;
-
-	// compute the padding if IP options are set
-	// multiple of 4 bytes
-	padding =  ipopt_length % 4;
-	if(padding){
-		padding = 4 - padding;
-		ipopt_length += padding;
-	}
-
-	// prefix the header
-	data = (uint8_t *) packet_prefix(packet, sizeof(ip_header_t) + padding);
-	if(! data){
-		return ENOMEM;
-	}
-
-	// add the padding
-	while(padding --){
-		data[sizeof(ip_header_t) + padding] = IPOPT_NOOP;
-	}
-
-	// set the header
-	header = (ip_header_ref) data;
-	header->header_length = IP_COMPUTE_HEADER_LENGTH(sizeof(ip_header_t) + ipopt_length);
-	header->ttl = (ttl ? ttl : IPDEFTTL); //(((ttl) <= MAXTTL) ? ttl : MAXTTL) : IPDEFTTL;
-	header->tos = tos;
-	header->protocol = protocol;
-
-	if(dont_fragment){
-		header->flags = IPFLAG_DONT_FRAGMENT;
-	}
-	return EOK;
-}
-
-int ip_client_process_packet(packet_t packet, ip_protocol_t * protocol, ip_ttl_t * ttl, ip_tos_t * tos, int * dont_fragment, size_t * ipopt_length){
-	ip_header_ref header;
-
-	header = (ip_header_ref) packet_get_data(packet);
-	if((! header)
-		|| (packet_get_data_length(packet) < sizeof(ip_header_t))){
-		return ENOMEM;
-	}
-
-	if(protocol){
-		*protocol = header->protocol;
-	}
-	if(ttl){
-		*ttl = header->ttl;
-	}
-	if(tos){
-		*tos = header->tos;
-	}
-	if(dont_fragment){
-		*dont_fragment = header->flags &IPFLAG_DONT_FRAGMENT;
-	}
-	if(ipopt_length){
-		*ipopt_length = IP_HEADER_LENGTH(header) - sizeof(ip_header_t);
-		return sizeof(ip_header_t);
-	}else{
-		return IP_HEADER_LENGTH(header);
-	}
-}
-
-int ip_client_set_pseudo_header_data_length(ip_pseudo_header_ref header, size_t headerlen, size_t data_length){
-	ipv4_pseudo_header_ref header_in;
-
-	if(! header){
-		return EBADMEM;
-	}
-
-	if(headerlen == sizeof(ipv4_pseudo_header_t)){
-		header_in = (ipv4_pseudo_header_ref) header;
-		header_in->data_length = htons(data_length);
-		return EOK;
-	// TODO IPv6
-	}else{
-		return EINVAL;
-	}
-}
-
 /** @}
  */
Index: uspace/srv/net/il/ip/ip_messages.h
===================================================================
--- uspace/srv/net/il/ip/ip_messages.h	(revision 60ab6c32bdd1487d23ce71b9720e1b79f4c121ed)
+++ uspace/srv/net/il/ip/ip_messages.h	(revision 71b00dcceb98187a198867584792b49778d8e886)
@@ -51,16 +51,16 @@
 	 */
 	NET_IP_ADD_ROUTE = NET_IP_FIRST,
-	/** Gets the actual route information.
-	 *  @see ip_get_route()
+	/** Sets the default gateway.
+	 *  @see ip_set_default_gateway()
 	 */
-	NET_IP_GET_ROUTE,
+	NET_IP_SET_GATEWAY,
 	/** Processes the received error notification.
 	 *  @see ip_received_error_msg()
 	 */
 	NET_IP_RECEIVED_ERROR,
-	/** Sets the default gateway.
-	 *  @see ip_set_default_gateway()
+	/** Gets the actual route information.
+	 *  @see ip_get_route()
 	 */
-	NET_IP_SET_GATEWAY
+	NET_IP_GET_ROUTE
 } ip_messages;
 
@@ -69,9 +69,4 @@
 /*@{*/
 
-/** Returns the address message parameter.
- *  @param[in] call The message call structure.
- */
-#define IP_GET_ADDRESS(call)		({in_addr_t addr; addr.s_addr = IPC_GET_ARG3(*call); addr;})
-
 /** Returns the gateway message parameter.
  *  @param[in] call The message call structure.
@@ -79,8 +74,8 @@
 #define IP_GET_GATEWAY(call)		({in_addr_t addr; addr.s_addr = IPC_GET_ARG2(*call); addr;})
 
-/** Sets the header length in the message answer.
- *  @param[out] answer The message answer structure.
+/** Returns the address message parameter.
+ *  @param[in] call The message call structure.
  */
-#define IP_SET_HEADERLEN(answer)	((size_t *) &IPC_GET_ARG2(*answer))
+#define IP_GET_ADDRESS(call)		({in_addr_t addr; addr.s_addr = IPC_GET_ARG3(*call); addr;})
 
 /** Returns the network mask message parameter.
@@ -94,4 +89,9 @@
 #define IP_GET_PROTOCOL(call)		((ip_protocol_t) IPC_GET_ARG1(*call))
 
+/** Sets the header length in the message answer.
+ *  @param[out] answer The message answer structure.
+ */
+#define IP_SET_HEADERLEN(answer)	((size_t *) &IPC_GET_ARG2(*answer))
+
 /*@}*/
 
Index: uspace/srv/net/inet.c
===================================================================
--- uspace/srv/net/inet.c	(revision 60ab6c32bdd1487d23ce71b9720e1b79f4c121ed)
+++ uspace/srv/net/inet.c	(revision 71b00dcceb98187a198867584792b49778d8e886)
@@ -45,45 +45,11 @@
 #include "include/socket_codes.h"
 
-int inet_ntop(uint16_t family, const uint8_t * data, char * address, size_t length){
-	if((! data) || (! address)){
-		return EINVAL;
-	}
-
-	switch(family){
-		case AF_INET:
-			// check the output buffer size
-			if(length < INET_ADDRSTRLEN){
-				return ENOMEM;
-			}
-			// fill the buffer with the IPv4 address
-			snprintf(address, length, "%hhu.%hhu.%hhu.%hhu", data[0], data[1], data[2], data[3]);
-			return EOK;
-		case AF_INET6:
-			// check the output buffer size
-			if(length < INET6_ADDRSTRLEN){
-				return ENOMEM;
-			}
-			// fill the buffer with the IPv6 address
-			snprintf(address, length, "%hhx%hhx:%hhx%hhx:%hhx%hhx:%hhx%hhx:%hhx%hhx:%hhx%hhx:%hhx%hhx:%hhx%hhx", data[0], data[1], data[2], data[3], data[4], data[5], data[6], data[7], data[8], data[9], data[10], data[11], data[12], data[13], data[14], data[15]);
-			return EOK;
-		default:
-			return ENOTSUP;
-	}
-}
-
 int inet_pton(uint16_t family, const char * address, uint8_t * data){
-	/** The base number of the values.
-	 */
-	int base;
-	/** The number of bytes per a section.
-	 */
-	size_t bytes;
-	/** The number of bytes of the address data.
-	 */
-	int count;
-
 	const char * next;
 	char * last;
 	int index;
+	int count;
+	int base;
+	size_t bytes;
 	size_t shift;
 	unsigned long value;
@@ -92,6 +58,4 @@
 		return EINVAL;
 	}
-
-	// set the processing parameters
 	switch(family){
 		case AF_INET:
@@ -108,31 +72,17 @@
 			return ENOTSUP;
 	}
-
-	// erase if no address
 	if(! address){
 		bzero(data, count);
 		return ENOENT;
 	}
-
-	// process the string from the beginning
 	next = address;
 	index = 0;
 	do{
-		// if the actual character is set
 		if(next && (*next)){
-
-			// if not on the first character
 			if(index){
-				// move to the next character
 				++ next;
 			}
-
-			// parse the actual integral value
 			value = strtoul(next, &last, base);
-			// remember the last problematic character
-			// should be either '.' or ':' but is ignored to be more generic
 			next = last;
-
-			// fill the address data byte by byte
 			shift = bytes - 1;
 			do{
@@ -141,14 +91,33 @@
 				value >>= 8;
 			}while(shift --);
-
 			index += bytes;
 		}else{
-			// erase the rest of the address
 			bzero(data + index, count - index);
 			return EOK;
 		}
 	}while(index < count);
+	return EOK;
+}
 
-	return EOK;
+int inet_ntop(uint16_t family, const uint8_t * data, char * address, size_t length){
+	if((! data) || (! address)){
+		return EINVAL;
+	}
+	switch(family){
+		case AF_INET:
+			if(length < INET_ADDRSTRLEN){
+				return ENOMEM;
+			}
+			snprintf(address, length, "%hhu.%hhu.%hhu.%hhu", data[0], data[1], data[2], data[3]);
+			return EOK;
+		case AF_INET6:
+			if(length < INET6_ADDRSTRLEN){
+				return ENOMEM;
+			}
+			snprintf(address, length, "%hhx%hhx:%hhx%hhx:%hhx%hhx:%hhx%hhx:%hhx%hhx:%hhx%hhx:%hhx%hhx:%hhx%hhx", data[0], data[1], data[2], data[3], data[4], data[5], data[6], data[7], data[8], data[9], data[10], data[11], data[12], data[13], data[14], data[15]);
+			return EOK;
+		default:
+			return ENOTSUP;
+	}
 }
 
